<template>
  <div
    :class="`modal fade ${shown ? 'show' : ''}`"
    @click="closeStatic"
    ref="backdrop"
  >
    <div class="modal-dialog modal-dialog-centered">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title">{{ title }}</h5>
          <button
            type="button"
            class="btn-close"
            aria-label="Close"
            @click="closeModal(false)"
          ></button>
        </div>
        <div class="modal-body" ref="body">
          <slot>No dialog body was provided</slot>
        </div>
        <div class="modal-footer">
          <button
            v-if="close !== null"
            type="button"
            class="btn btn-secondary"
            @click="closeModal(false)"
          >
            {{ close }}
          </button>
          <button
            v-if="confirm !== null"
            type="button"
            class="btn btn-primary"
            :disabled="processing"
            @click="closeModal(true)"
          >
            <i v-if="processing" class="fas fa-circle-notch rotate"></i>
            {{ confirm }}
          </button>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: "ModalDialog",
  emits: ["close"],
  data() {
    return {
      shown: true,
    };
  },
  mounted() {
    this.shown = this.show;
    window.addEventListener("keydown", this.keyDown);
  },
  props: {
    title: {
      type: String,
      default: "Untitled Dialog",
    },
    confirm: {
      // No confirm button on `null`
      type: String,
      default: "Save",
    },
    show: {
      type: Boolean,
      default: true,
    },
    close: {
      // No close button on `null` (only standard topright)
      type: String,
      default: "Close",
    },
    static: {
      type: Boolean,
      default: false,
    },
    processing: {
      // Displays spinner on confirm button
      type: Boolean,
      default: false,
    },
  },
  methods: {
    keyDown(ev) {
      if (ev.key === "Escape") this.closeModal(false);
    },
    closeModal(value) {
      this.$emit("close", { value, body: this.$refs.body });
      this.shown = false;
    },
    closeStatic(event) {
      if (!this.static && event.target == this.$refs.backdrop) {
        this.closeModal(false);
      }
    },
  },
};
</script>

<style lang="scss">
.modal {
  background: rgba(0, 0, 0, 0.5);
  &.show {
    display: block;
  }
}

@keyframes rotate-spinner {
  from {
    transform: rotate(0deg);
  }
  to {
    transform: rotate(360deg);
  }
}

i.rotate {
  display: inline-block;
  animation: rotate-spinner 750ms infinite ease-in-out;
}
</style>
